import request from "@/utils/request";
import { AxiosPromise } from "axios";
import { FileInfo } from "./types";

export function uploadFileApi(
  file: File,
  generatePdf: boolean = false
): AxiosPromise<FileInfo> {
  const formData = new FormData();
  console.log(file);
  formData.append("file", file);
  formData.append("fileName", file.name);
  formData.append("generatePdf", generatePdf);
  return request({
    url: "/api/v1/base/upload",
    method: "post",
    data: formData,
    headers: {
      "Content-Type": "multipart/form-data",
    },
  });
}

/**
 * 删除文件
 *
 * @param filePath 文件完整路径
 */
export function deleteFileApi(filePath?: string) {
  return request({
    url: "/api/v1/files",
    method: "delete",
    params: { filePath: filePath },
  });
}
