import type { App } from "vue";
import { createPinia } from "pinia";
import piniaPersist from "pinia-plugin-persist";

const store = createPinia();
store.use(piniaPersist);

// 全局注册 store
export function setupStore(app: App<Element>) {
  app.use(store);
}

export * from "./modules/app";
export * from "./modules/permission";
export * from "./modules/settings";
export * from "./modules/tagsView";
export * from "./modules/user";
export * from "./modules/common";
export * from "./modules/dictionary";
export { store };
