import { store } from "@/store";
import { defineStore } from "pinia";
import { getUserDicts } from "@/api/auth";

export const useDictionaryStore = defineStore("dictionaryStore", () => {
  const types = [
    "station_type",
    "station_operate_type",
    "applicable_platforms",
    "material_properties",
    "quality_testing_plan",
    "material_level",
    "packaging_method",
    "quality_grade",
    "selection_type",
    "device_type",
    "stage",
    "danwei_type",
    "process_type",
    "workshop_section",
    "skill_requirements",
    "accessories_type",
    "trace_type",
    "skill_type",
    "drawing_type",
    "vehicle_level",
    "fault_current_state",
    "escalation_fault_state",
    "defect_mana",
    "disposal_measures_type",
    "process_check_result",
    "excel_type",
    "excel_states",
    "process_state",
    "form_params",
    "bill_type",
      "flow_ins_state",
    "warehouse_type",
    "signature_type",
    "signature_attribution",
    "accessories_property",
  ];
  const dicts = ref<{ [key: string]: any[] }>({});

  return {
    types,
    dicts,
  };
});

export function useDictionaryStoreHook() {
  // console.log('dicts:',useDictionaryStore(store))
  return useDictionaryStore(store);
}
